# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from vulncheck_sdk.models.advisory_siemens_generator import AdvisorySiemensGenerator
from vulncheck_sdk.models.advisory_siemens_revision_history import AdvisorySiemensRevisionHistory
from typing import Optional, Set
from typing_extensions import Self

class AdvisorySiemensTracking(BaseModel):
    """
    AdvisorySiemensTracking
    """ # noqa: E501
    current_release_date: Optional[StrictStr] = None
    generator: Optional[AdvisorySiemensGenerator] = None
    id: Optional[StrictStr] = None
    initial_release_date: Optional[StrictStr] = None
    revision_history: Optional[List[AdvisorySiemensRevisionHistory]] = None
    status: Optional[StrictStr] = None
    version: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["current_release_date", "generator", "id", "initial_release_date", "revision_history", "status", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisorySiemensTracking from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of generator
        if self.generator:
            _dict['generator'] = self.generator.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in revision_history (list)
        _items = []
        if self.revision_history:
            for _item_revision_history in self.revision_history:
                if _item_revision_history:
                    _items.append(_item_revision_history.to_dict())
            _dict['revision_history'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisorySiemensTracking from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "current_release_date": obj.get("current_release_date"),
            "generator": AdvisorySiemensGenerator.from_dict(obj["generator"]) if obj.get("generator") is not None else None,
            "id": obj.get("id"),
            "initial_release_date": obj.get("initial_release_date"),
            "revision_history": [AdvisorySiemensRevisionHistory.from_dict(_item) for _item in obj["revision_history"]] if obj.get("revision_history") is not None else None,
            "status": obj.get("status"),
            "version": obj.get("version")
        })
        return _obj


