# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AdvisoryITWExploit(BaseModel):
    """
    AdvisoryITWExploit
    """ # noqa: E501
    advisory: Optional[StrictStr] = None
    affected_versions: Optional[StrictStr] = None
    analysis_url: Optional[StrictStr] = None
    bug_introducing_change_list_url: Optional[StrictStr] = None
    claimed_attribution: Optional[StrictStr] = None
    claimed_attribution_url: Optional[StrictStr] = None
    cve: Optional[List[StrictStr]] = None
    date_added: Optional[StrictStr] = None
    date_discovered: Optional[StrictStr] = None
    date_patched: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    first_patched_version: Optional[StrictStr] = None
    patch_change_list_url: Optional[StrictStr] = None
    product: Optional[StrictStr] = None
    reported_by: Optional[StrictStr] = None
    root_cause_analysis_url: Optional[StrictStr] = None
    vendor: Optional[StrictStr] = None
    vulnerability_type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["advisory", "affected_versions", "analysis_url", "bug_introducing_change_list_url", "claimed_attribution", "claimed_attribution_url", "cve", "date_added", "date_discovered", "date_patched", "description", "first_patched_version", "patch_change_list_url", "product", "reported_by", "root_cause_analysis_url", "vendor", "vulnerability_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisoryITWExploit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisoryITWExploit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "advisory": obj.get("advisory"),
            "affected_versions": obj.get("affected_versions"),
            "analysis_url": obj.get("analysis_url"),
            "bug_introducing_change_list_url": obj.get("bug_introducing_change_list_url"),
            "claimed_attribution": obj.get("claimed_attribution"),
            "claimed_attribution_url": obj.get("claimed_attribution_url"),
            "cve": obj.get("cve"),
            "date_added": obj.get("date_added"),
            "date_discovered": obj.get("date_discovered"),
            "date_patched": obj.get("date_patched"),
            "description": obj.get("description"),
            "first_patched_version": obj.get("first_patched_version"),
            "patch_change_list_url": obj.get("patch_change_list_url"),
            "product": obj.get("product"),
            "reported_by": obj.get("reported_by"),
            "root_cause_analysis_url": obj.get("root_cause_analysis_url"),
            "vendor": obj.get("vendor"),
            "vulnerability_type": obj.get("vulnerability_type")
        })
        return _obj


